package repository

import (
	"fmt"
	"strings"

	dborm "be.ems/lib/core/datasource"
	"be.ems/lib/log"
	"be.ems/src/framework/datasource"
	"be.ems/src/framework/logger"
	"be.ems/src/framework/utils/parse"
	"be.ems/src/framework/utils/repo"
	"be.ems/src/modules/network_data/model"
)

// 实例化数据层 UDMSubUser 结构体
var NewUDMSub = &UDMSubUser{
	selectSql: `select 
	s.id, s.imsi, s.msisdn, s.ne_id, 
	s.am_dat, s.ambr, s.nssai, s.rat, s.arfb, s.sar, s.cn_type, s.rfsp_index, s.reg_timer, s.ue_usage_type, s.active_time, s.mico, s.odb_ps, s.group_id, 
	s.eps_dat, s.eps_flag, s.eps_odb, s.hplmn_odb, s.ard, s.epstpl, s.context_id, s.apn_mum, s.apn_context, s.static_ip, 
	s.sm_data, s.smf_sel, s.cag,
	t.tenant_id, t.tenant_name
	from u_sub_user s
	left join sys_tenant t on t.tenant_id = s.tenant_id and t.status = 1`,

	resultMap: map[string]string{
		"id":     "ID",
		"imsi":   "IMSI",
		"msisdn": "MSISDN",
		"ne_id":  "NeId",

		"am_dat":        "AmDat",
		"ambr":          "UeAmbrTpl",
		"nssai":         "NssaiTpl",
		"rat":           "RatRestrictions",
		"arfb":          "AreaForbiddenTpl",
		"sar":           "ServiceAreaRestrictionTpl",
		"cn_type":       "CnTypeRestrictions",
		"rfsp_index":    "RfspIndex",
		"reg_timer":     "SubsRegTime",
		"ue_usage_type": "UeUsageType",
		"active_time":   "ActiveTime",
		"mico":          "MicoAllowed",
		"odb_ps":        "OdbPs",
		"group_id":      "GroupId",

		"eps_dat":     "EpsDat",
		"eps_flag":    "EpsFlag",
		"eps_odb":     "EpsOdb",
		"hplmn_odb":   "HplmnOdb",
		"ard":         "Ard",
		"epstpl":      "Epstpl",
		"context_id":  "ContextId",
		"apn_mum":     "ApnNum",
		"apn_context": "ApnContext",
		"static_ip":   "StaticIp",

		"sm_data": "SmData",
		"smf_sel": "SmfSel",
		"cag":     "Cag",

		"tenant_id":   "TenantID",
		"tenant_name": "TenantName", // Tenant name for multi-tenancy
	},
}

// UDMSubUser UDM签约信息表 数据层处理
type UDMSubUser struct {
	// 查询视图对象SQL
	selectSql string
	// 结果字段与实体映射
	resultMap map[string]string
}

// convertResultRows 将结果记录转实体结果组
func (r *UDMSubUser) convertResultRows(rows []map[string]any) []model.UDMSubUser {
	arr := make([]model.UDMSubUser, 0)
	for _, row := range rows {
		item := model.UDMSubUser{}
		for key, value := range row {
			if keyMapper, ok := r.resultMap[key]; ok {
				repo.SetFieldValue(&item, keyMapper, value)
			}
		}
		arr = append(arr, item)
	}
	return arr
}

// ClearAndInsert 清空ne_id后新增实体
func (r *UDMSubUser) ClearAndInsert(neId string, u []model.UDMSubUser) int64 {
	// 不指定neID时，用 TRUNCATE 清空表快
	// _, err := datasource.ExecDB("", "TRUNCATE TABLE u_sub_user", nil)
	_, err := datasource.ExecDB("", "DELETE FROM u_sub_user WHERE ne_id = ?", []any{neId})
	if err != nil {
		logger.Errorf("TRUNCATE err => %v", err)
	}

	return r.Inserts(u)
}

// SelectPage 根据条件分页查询字典类型
func (r *UDMSubUser) SelectPage(query map[string]any) map[string]any {
	// 查询条件拼接
	var conditions []string
	var params []any
	if v, ok := query["imsi"]; ok && v != "" {
		conditions = append(conditions, "imsi like concat(concat('%', ?), '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["msisdn"]; ok && v != "" {
		conditions = append(conditions, "msisdn like concat(concat('%', ?), '%')")
		params = append(params, strings.Trim(v.(string), " "))
	}
	if v, ok := query["imsis"]; ok && v != "" {
		placeholder := repo.KeyPlaceholderByQuery(len(v.([]any)))
		conditions = append(conditions, fmt.Sprintf("imsi in (%s)", placeholder))
		for _, v := range v.([]any) {
			params = append(params, v.(string))
		}
	}

	// for multi-tenancy solution
	if v, ok := query["tenantName"]; ok && v != "" {
		var tenantID []string
		err := dborm.DefaultDB().Table("sys_tenant").
			Where("tenant_name=? and status=1", v).Cols("tenant_id").Distinct().Find(&tenantID)
		if err != nil {
			log.Errorf("Find tenant_id from sys_user err => %v", err)
		}
		log.Tracef("userName=%v, tenantID=%v", v, tenantID)
		if len(tenantID) > 0 {
			conditions = append(conditions, "s.tenant_id = ?")
			params = append(params, tenantID[0])
		}
	} else if v, ok := query["userName"]; ok && v != "" {
		var tenantID string
		_, err := dborm.DefaultDB().Table("sys_user").
			Where("user_name=?", v).Cols("tenant_id").Distinct().Get(&tenantID)
		if err != nil {
			log.Errorf("Find tenant_id from sys_user err => %v", err)
		}
		log.Tracef("userName=%v, tenantID=%v", v, tenantID)
		if tenantID != "" {
			conditions = append(conditions, "s.tenant_id = ?")
			params = append(params, tenantID)
			query["neId"] = ""
		}
	}
	if v, ok := query["neId"]; ok && v != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, v)
	}
	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	result := map[string]any{
		"total": 0,
		"rows":  []model.UDMSubUser{},
	}

	// 查询数量 长度为0直接返回
	totalSql := "select count(1) as 'total' from u_sub_user s"
	totalRows, err := datasource.RawDB("", totalSql+whereSql, params)
	if err != nil {
		logger.Errorf("total err => %v", err)
		return result
	}
	total := parse.Number(totalRows[0]["total"])
	if total == 0 {
		return result
	} else {
		result["total"] = total
	}

	// 分页
	pageNum, pageSize := repo.PageNumSize(query["pageNum"], query["pageSize"])
	pageSql := " limit ?,? "
	params = append(params, pageNum*pageSize)
	params = append(params, pageSize)

	// 排序
	orderSql := ""
	if v, ok := query["sortField"]; ok && v != "" {
		sortSql := v.(string)
		if o, ok := query["sortOrder"]; ok && o != nil && v != "" {
			if o == "desc" {
				sortSql += " desc "
			} else {
				sortSql += " asc "
			}
		}
		orderSql = fmt.Sprintf(" order by %s ", sortSql)
	}

	// 查询数据
	querySql := r.selectSql + whereSql + orderSql + pageSql
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
		return result
	}

	// 转换实体
	result["rows"] = r.convertResultRows(results)
	return result
}

// SelectList 根据实体查询
func (r *UDMSubUser) SelectList(u model.UDMSubUser) []model.UDMSubUser {
	// 查询条件拼接
	var conditions []string
	var params []any
	if u.IMSI != "" {
		conditions = append(conditions, "imsi = ?")
		params = append(params, u.IMSI)
	}
	if u.NeId != "" {
		conditions = append(conditions, "ne_id = ?")
		params = append(params, u.NeId)
	}

	// 构建查询条件语句
	whereSql := ""
	if len(conditions) > 0 {
		whereSql += " where " + strings.Join(conditions, " and ")
	}

	// 查询数据
	querySql := r.selectSql + whereSql + " order by imsi asc "
	results, err := datasource.RawDB("", querySql, params)
	if err != nil {
		logger.Errorf("query err => %v", err)
	}

	// 转换实体
	return r.convertResultRows(results)
}

// SelectByIMSIAndNeID 通过imsi和ne_id查询
func (r *UDMSubUser) SelectByIMSIAndNeID(imsi, neId string) model.UDMSubUser {
	querySql := r.selectSql + " where imsi = ? and ne_id = ?"
	results, err := datasource.RawDB("", querySql, []any{imsi, neId})
	if err != nil {
		logger.Errorf("query err => %v", err)
		return model.UDMSubUser{}
	}
	// 转换实体
	rows := r.convertResultRows(results)
	if len(rows) > 0 {
		return rows[0]
	}
	return model.UDMSubUser{}
}

// Insert 批量添加
func (r *UDMSubUser) Inserts(uArr []model.UDMSubUser) int64 {
	// multi-tenancy
	r.SetTenantID(&uArr)

	tx := datasource.DefaultDB().CreateInBatches(uArr, 2000)
	if err := tx.Error; err != nil {
		logger.Errorf("CreateInBatches err => %v", err)
	}
	return tx.RowsAffected
}

// Delete 删除实体
func (r *UDMSubUser) Delete(imsi, neId string) int64 {
	tx := datasource.DefaultDB().Where("imsi = ? and ne_id = ?", imsi, neId).Delete(&model.UDMSubUser{})
	if err := tx.Error; err != nil {
		logger.Errorf("Delete err => %v", err)
	}
	return tx.RowsAffected
}

// DeletePrefixByIMSI 删除前缀匹配的实体
func (r *UDMSubUser) DeletePrefixByIMSI(imsiPrefix, neId string) int64 {
	tx := datasource.DefaultDB().Where("imsi like concat(?, '%') and ne_id = ?", imsiPrefix, neId).Delete(&model.UDMSubUser{})
	if err := tx.Error; err != nil {
		logger.Errorf("DeletePrefixByIMSI err => %v", err)
	}
	return tx.RowsAffected
}

func (r *UDMSubUser) SetTenantID(subArr *[]model.UDMSubUser) {
	for s := 0; s < len(*subArr); s++ {
		var tenantID []string
		err := dborm.DefaultDB().Table("sys_tenant").
			Where("status='1' and tenancy_type='IMSI' and ? like tenancy_key", (*subArr)[s].IMSI).
			Cols("parent_id").Distinct().Find(&tenantID)
		if err != nil {
			logger.Errorf("Find tenant_id err => %v", err)
			continue
		}
		if len(tenantID) > 0 {
			(*subArr)[s].TenantID = tenantID[0]
		}
	}
}
